"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var withProps = function withProps(props) {
  return function (baseFn) {
    if (!baseFn) {
      baseFn = function baseFn() {
        this.construct();
      };
    }

    if (!baseFn.__withProps) {
      baseFn.__withProps = [];

      baseFn.prototype.construct = function () {
        var _this = this;

        this.constructor.__withProps.forEach(function (propsToAssign) {
          if (typeof propsToAssign === "function") {
            Object.defineProperties(_this, Object.getOwnPropertyDescriptors(propsToAssign(_this)));
          } else {
            Object.defineProperties(_this, Object.getOwnPropertyDescriptors(propsToAssign));
          }
        });
      };
    }

    baseFn.__withProps.push(props);

    return baseFn;
  };
};

var _default = withProps;
exports.default = _default;
//# sourceMappingURL=withProps.js.map